#include<avr/io.h>
#include<avr/interrupt.h>
#include<util/delay.h>
#include<avr/pgmspace.h>
#include "usbdrv.h"
#include <stdio.h>

#define VENDOR_RQ_SET_LED 0


char in_b(char pin)
{
DDRB &= ~(1<<pin);
return ((PINB & (1<<pin))>>pin);
}

out_b(char pin,char val)
{
DDRB |= 1<<pin;
if(val)
PORTB |= 1<<pin;
else
PORTB &= ~(1<<pin);
}
char in_c(char pin)
{
DDRC &= ~(1<<pin);
return ((PINC & (1<<pin))>>pin);
}

out_c(char pin,char val)
{
DDRC |= 1<<pin;
if(val)
PORTC |= 1<<pin;
else
PORTC &= ~(1<<pin);
}

uint16_t read_adc(uint8_t channel)
{
ADMUX = 0x40;
ADMUX |= channel;
ADCSRA = 0xc6;
while((ADCSRA & (1<<ADSC)))
;
return ADCL + ADCH*256;
}

usbMsgLen_t usbFunctionSetup(uchar data[8])
{
usbRequest_t *rq = (void *)data;
static uchar dataBuffer[2];
if(rq->bRequest == VENDOR_RQ_SET_LED)
{
	uint8_t led_no = rq->wValue.bytes[0];
	uint8_t led_val = rq->wValue.bytes[1];
	if(led_no>3)
	{
		out_b(led_no-4,led_val);
	} // if led_no>=4 change to port b
	else 
	{
	out_c(led_no,led_val); // else use port c
	}
return 0;
}
return 0;
}


main()
{
//led no 0-3,portc led no 4-6 portb,led no 7 port b show draw
DDRB = 0b00111111;
PORTB = 0b00000000;
DDRC = 0b00111111;
PORTC = 0b00000000;
DDRD = 0b00001000;
PORTD = 0b00000000;
usbInit();
usbDeviceDisconnect();
_delay_ms(300);
usbDeviceConnect();
sei();
while(1)
usbPoll();
}
